diff -uNr expat.orig/Portfile expat/Portfile
--- expat.orig/Portfile	Mon Aug 18 13:54:14 2003
+++ expat/Portfile	Tue Oct 21 00:37:02 2003
@@ -2,16 +2,17 @@
 
 PortSystem 1.0
 name		expat
-version		1.95.6
+version		1.95.7
 categories	textproc
 platforms	darwin
 maintainers	blb@pobox.com
 description	XML 1.0 parser written in C
 master_sites.mirror_subdir	expat
 master_sites	sourceforge
-checksums	md5 ca78d94e83e9f077b5da2bfe28ba986a
-patchfiles	patch-expat.h
+checksums	md5 2ff59c2a5cbdd21a285c5f343e214fa9
+patchfiles	patch-Makefile.in
 
-configure.args	--enable-static=no
+configure.args	--disable-static --mandir=\\\${prefix}/share/man
 
 destroot.destdir prefix=${destroot}/${prefix}
+
diff -uNr expat.orig/files/patch-Makefile.in expat/files/patch-Makefile.in
--- expat.orig/files/patch-Makefile.in	Wed Dec 31 17:00:00 1969
+++ expat/files/patch-Makefile.in	Tue Oct 21 00:28:57 2003
@@ -0,0 +1,32 @@
+--- Makefile.in.orig	Wed Oct 15 22:51:11 2003
++++ Makefile.in	Tue Oct 21 00:28:26 2003
+@@ -30,7 +30,7 @@
+ bindir = @bindir@
+ libdir = @libdir@
+ includedir = @includedir@
+-mandir = ${prefix}/man/man1
++mandir = @mandir@
+ 
+ top_builddir = .
+ 
+@@ -73,9 +73,9 @@
+ 	tests/runtests
+ 
+ install: xmlwf/xmlwf installlib
+-	$(mkinstalldirs) $(bindir) $(mandir)
++	$(mkinstalldirs) $(bindir) $(mandir) $(mandir)/man1
+ 	$(LIBTOOL) --mode=install $(INSTALL_PROGRAM) xmlwf/xmlwf $(bindir)/xmlwf
+-	$(INSTALL_DATA) $(MANFILE) $(mandir)
++	$(INSTALL_DATA) $(MANFILE) $(mandir)/man1
+ 
+ installlib: $(LIBRARY) $(APIHEADER)
+ 	$(mkinstalldirs) $(libdir) $(includedir)
+@@ -84,7 +84,7 @@
+ 
+ uninstall: uninstalllib
+ 	$(LIBTOOL) --mode=uninstall rm -f $(bindir)/xmlwf
+-	rm -f $(mandir)/xmlwf.1
++	rm -f $(mandir)/man1/xmlwf.1
+ 
+ uninstalllib:
+ 	$(LIBTOOL) --mode=uninstall rm -f $(libdir)/$(LIBRARY)
diff -uNr expat.orig/files/patch-expat.h expat/files/patch-expat.h
--- expat.orig/files/patch-expat.h	Sun Aug 17 17:34:35 2003
+++ expat/files/patch-expat.h	Wed Dec 31 17:00:00 1969
@@ -1,69 +0,0 @@
---- lib/expat.h    Thu Jan 16 15:03:42 2003
-+++ lib/expat.h    Wed May 21 11:38:14 2003
-@@ -647,6 +647,32 @@
- /* Returns the last value set by XML_SetUserData or NULL. */
- #define XML_GetUserData(parser) (*(void **)(parser))
- 
-+/* Parses some input. Returns XML_STATUS_ERROR if a fatal error is
-+   detected.  The last call to XML_Parse must have isFinal true; len
-+   may be zero for this call (or any other).
-+
-+   The XML_Status enum gives the possible return values for the
-+   XML_Parse and XML_ParseBuffer functions.  Though the return values
-+   for these functions has always been described as a Boolean value,
-+   the implementation, at least for the 1.95.x series, has always
-+   returned exactly one of these values.  The preprocessor #defines
-+   are included so this stanza can be added to code that still needs
-+   to support older versions of Expat 1.95.x:
-+
-+   #ifndef XML_STATUS_OK 
-+   #define XML_STATUS_OK    1
-+   #define XML_STATUS_ERROR 0
-+   #endif
-+
-+   Otherwise, the #define hackery is quite ugly and would have been dropped.
-+*/
-+enum XML_Status {
-+  XML_STATUS_ERROR = 0,     
-+#define XML_STATUS_ERROR XML_STATUS_ERROR
-+  XML_STATUS_OK = 1
-+#define XML_STATUS_OK XML_STATUS_OK
-+};
-+
- /* This is equivalent to supplying an encoding argument to
-    XML_ParserCreate. On success XML_SetEncoding returns non-zero,
-    zero otherwise.
-@@ -712,32 +738,6 @@
- */
- XMLPARSEAPI(int)
- XML_GetIdAttributeIndex(XML_Parser parser);
--
--/* Parses some input. Returns XML_STATUS_ERROR if a fatal error is
--   detected.  The last call to XML_Parse must have isFinal true; len
--   may be zero for this call (or any other).
--
--   The XML_Status enum gives the possible return values for the
--   XML_Parse and XML_ParseBuffer functions.  Though the return values
--   for these functions has always been described as a Boolean value,
--   the implementation, at least for the 1.95.x series, has always
--   returned exactly one of these values.  The preprocessor #defines
--   are included so this stanza can be added to code that still needs
--   to support older versions of Expat 1.95.x:
--
--   #ifndef XML_STATUS_OK
--   #define XML_STATUS_OK    1
--   #define XML_STATUS_ERROR 0
--   #endif
--
--   Otherwise, the #define hackery is quite ugly and would have been dropped.
--*/
--enum XML_Status {
--  XML_STATUS_ERROR = 0,
--#define XML_STATUS_ERROR XML_STATUS_ERROR
--  XML_STATUS_OK = 1
--#define XML_STATUS_OK XML_STATUS_OK
--};
- 
- XMLPARSEAPI(enum XML_Status)
- XML_Parse(XML_Parser parser, const char *s, int len, int isFinal);
-