Index: Portfile
===================================================================
RCS file: /Volumes/src/cvs/od/proj/darwinports/dports/editors/vim/Portfile,v
retrieving revision 1.39
diff -w -u -r1.39 Portfile
--- Portfile	19 Aug 2003 03:55:12 -0000	1.39
+++ Portfile	15 Jan 2004 22:11:58 -0000
@@ -2,7 +2,7 @@
 
 PortSystem 1.0
 name			vim
-set vim_patchlevel	61
+set vim_patchlevel	181
 version			6.2.$vim_patchlevel
 categories		editors
 maintainers		mij@opendarwin.org
@@ -13,34 +13,99 @@
 long_description	Vim is a virtually compatible, extremely \
 			enhanced version of the vi editor.
 
-master_sites		ftp://ftp.vim.org/pub/vim/unix/ \
-			ftp://ftp.us.vim.org/pub/vim/unix/ \
-			ftp://ftp2.us.vim.org/pub/vim/unix/ \
-			ftp://ftp3.us.vim.org/pub/vim/unix/pub/mirrors/ftp.vim.org/vim/ \
-			ftp://ftp.is.co.za/applications/editors/vim/unix/ \
-			ftp://ftp.prz.tu-berlin.de/pub/unix/editors/vim/unix/ \
-			ftp://ftp.mirror.ac.uk/sites/ftp.vim.org/pub/vim/unix/
 
-eval patch_sites	[strsed $master_sites g/unix/patches/]
+set dist_version [strsed $version {s/\.[0-9]*$//}]
 
-dist_subdir		vim
-distname		$portname-[strsed $portversion {s/\.[0-9]*$//}]
-worksrcdir		vim62
+distfiles	$name-$dist_version-src1.tar.gz:vim \
+			$name-$dist_version-src2.tar.gz:vim \
+			$name-$dist_version-rt1.tar.gz:vim \
+			$name-$dist_version-rt2.tar.gz:vim \
+			$name-$dist_version-extra.tar.gz:extra \
+			$name-$dist_version-lang.tar.gz:extra
+
+master_sites	ftp://ftp.vim.org/pub/vim/unix/:vim \
+				ftp://ftp.us.vim.org/pub/vim/unix/:vim \
+				ftp://ftp2.us.vim.org/pub/vim/unix/:vim \
+				ftp://ftp3.us.vim.org/pub/vim/unix/pub/mirrors/ftp.vim.org/vim/:vim \
+				ftp://ftp.is.co.za/applications/editors/vim/unix/:vim \
+				ftp://ftp.prz.tu-berlin.de/pub/unix/editors/vim/unix/:vim \
+				ftp://ftp.mirror.ac.uk/sites/ftp.vim.org/pub/vim/unix/:vim \
+				ftp://ftp.vim.org/pub/vim/extra/:extra\
+				ftp://ftp.us.vim.org/pub/vim/extra/:extra \
+				ftp://ftp2.us.vim.org/pub/vim/extra/:extra \
+				ftp://ftp3.us.vim.org/pub/vim/extra/pub/mirrors/ftp.vim.org/vim/:extra \
+				ftp://ftp.is.co.za/applications/editors/vim/extra/:extra \
+				ftp://ftp.prz.tu-berlin.de/pub/unix/editors/vim/extra/:extra \
+				ftp://ftp.mirror.ac.uk/sites/ftp.vim.org/pub/vim/extra/:extra
+
+eval patch_sites	[strsed [strsed ${master_sites} g/unix/patches/] g/:vim//]
 
-use_bzip2		yes
+dist_subdir		vim
+distname		vim62
 
 configure.args		--enable-gui=no --without-x --disable-gpm
 
-set vim_badpatches	"009 013 019 022 023 024 033 036 038 039 041 042 047 056 057 060"
+set vim_badpatches	{}
 
 eval patchfiles		[split [exec /usr/bin/jot -s " " -w \
-			[strsed $portversion {s/\.[0-9]*$//}].%03d \
+			[strsed $version {s/\.[0-9]*$//}].%03d \
 			$vim_patchlevel 1 $vim_patchlevel] " "]
 
 foreach p ${vim_badpatches} {
 			patchfiles-delete 6.2.${p}
 }
 
+variant aqua	{
+	master_sites-append		http://www.douglas.stebila.ca/code/vim/app/:app_aqua \
+							http://www.douglas.stebila.ca/code/vim/doc/:doc_aqua \
+							http://macvim.swdev.org/OSX/files/:osx_aqua
+	distfiles-append		app.tar.gz:app_aqua \
+							doc.tar.gz:doc_aqua \
+							macrt.tar.bz2:osx_aqua \
+							gvim.app.tgz:osx_aqua
+	checksums-append		app.tar.gz md5 19b2d3dd6f5ba161e55186e7a1c11c5b \
+							doc.tar.gz md5 692f7874fc617162d0fe110daf39a98a \
+							macrt.tar.bz2 md5 f0b89d856ba60015006f87cb951fe8a9 \
+							gvim.app.tgz md5 9bf75f5b661d2e9cd6a6f346a821b24e
+	extract.only-delete		macrt.tar.bz2 \
+							gvim.app.tgz
+	post-extract {
+		ui_info "$UI_PREFIX Extracting macrt.tar.bz2"
+		system "cd ${workpath} && \
+			bzip2 -dc ${distpath}/macrt.tar.bz2 | tar xf -"
+		ui_info "Done"
+		ui_info "$UI_PREFIX Extracting gvim.app.tgz"
+		system "cd ${workpath} && \
+			gzip -dc ${distpath}/gvim.app.tgz | tar xf -"
+		ui_info "Done"
+	}
+	configure.args	{}
+	post-configure	{
+		reinplace "s|/Applications/vim|/Applications/DarwinPorts/Vim|" ${workpath}/gvim
+		reinplace "s|/Applications/vim|/Applications/DarwinPorts/Vim|" ${workpath}/gvim.app/Contents/Resources/script
+	}
+	post-destroot	{
+		xinstall -d -m 755 ${destroot}/Applications/DarwinPorts
+		system "ditto -rsrcFork ${workpath}/gvim.app \
+			${destroot}/Applications/DarwinPorts/GVim.app"
+		xinstall -d -m 755 ${destroot}/Applications/DarwinPorts/Vim
+		system "ditto -rsrcFork ${worksrcpath}/src/Vim.app \
+			${destroot}/Applications/DarwinPorts/Vim/Vim.app"
+		system "ln -s -f /Applications/DarwinPorts/Vim/Vim.app/Contents/MacOS/Vim \
+			${destroot}/${prefix}/bin/vim"
+		xinstall -m 755 ${workpath}/gvim ${destroot}/${prefix}/bin/
+		system "ditto ${workpath}/runtime \
+			${destroot}/Applications/DarwinPorts/Vim/Vim.app/runtime"
+		xinstall -m 644 ${workpath}/gvimrc \
+			${destroot}/Applications/DarwinPorts/Vim/Vim.app/
+		xinstall -m 644 ${workpath}/vimrc \
+			${destroot}/Applications/DarwinPorts/Vim/Vim.app/
+		xinstall -m 644 ${workpath}/doc-txt.icns \
+			${destroot}/Applications/DarwinPorts/Vim/Vim.app/Contents/Resources/
+		xinstall -m 644 ${workpath}/app.icns \
+			${destroot}/Applications/DarwinPorts/Vim/Vim.app/Contents/Resources/gui_mac.icns
+	}
+}
 variant x11		{ configure.args --enable-gui=auto --with-x }
 variant tiny		{ configure.args-append	--with-features=tiny }
 variant small		{ configure.args-append	--with-features=small }
@@ -50,3 +115,4 @@
 variant ncurses		{ configure.args-append --with-tlib=ncurses }
 
 include checksums
+
Index: checksums
===================================================================
RCS file: /Volumes/src/cvs/od/proj/darwinports/dports/editors/vim/checksums,v
retrieving revision 1.15
diff -w -u -r1.15 checksums
--- checksums	15 Aug 2003 06:13:46 -0000	1.15
+++ checksums	15 Jan 2004 22:11:58 -0000
@@ -1,4 +1,9 @@
-checksums		vim-6.2.tar.bz2 md5 c49d360bbd069d00e2a57804f2a123d9 \
+checksums	vim-6.2-src1.tar.gz md5 32b1d1ef61a8bc1fd861e14cc966d296 \
+			vim-6.2-src2.tar.gz md5 58817309e36b1ece964d40a5c55d532e \
+			vim-6.2-rt1.tar.gz md5 c67ac26f4569e9dc9fc319510fa95f7a \
+			vim-6.2-rt2.tar.gz md5 f6b0fdc7ad42716910857c73230a75c4 \
+			vim-6.2-extra.tar.gz md5 db0db37baea01874867d8d2414db104c \
+			vim-6.2-lang.tar.gz md5 aa0079938f636d08be71078933477d8b \
 			6.2.001 md5 02588ec10aff5a6f2a017d6edb37cd69 \
 			6.2.002 md5 01483a452ebfa13855c0d8ef57484671 \
 			6.2.003 md5 20d45613b76ea2ad548926e399451852 \
@@ -7,9 +12,11 @@
 			6.2.006 md5 cc0d438053196e723649643402da386f \
 			6.2.007 md5 97cfb7d499f1249d3125b52a6f14e96a \
 			6.2.008 md5 6717f22d2c8bfc55ce3f28c4df0cfd23 \
+			6.2.009 md5 0df4c6e2673cd3a629da5b79b5cef789 \
 			6.2.010 md5 b6625937784e219ebdc75087b7c03678 \
 			6.2.011 md5 03bf70f97496a7b68416b0bf687ac77e \
 			6.2.012 md5 e2ff4e3acdd33ab5325b23a0fccd7db2 \
+			6.2.013 md5 66f1668e3be83cae60a0553edb9c08f2 \
 			6.2.014 md5 2f0b2b23c7085e7ccf0b2fd07ac0efd6 \
 			6.2.015 md5 22c5842c56f5c473ae149a665ae4b978 \
 			6.2.016 md5 dbca966871be4c46bafd0621ca80de13 \
@@ -18,6 +25,9 @@
 			6.2.019 md5 c44736a0ac243cee7fae05b94cdb4177 \
 			6.2.020 md5 dd1db97c918ae8832b011752080c6a45 \
 			6.2.021 md5 bc977a0d554bb5ce1776037cc6d84fde \
+			6.2.022 md5 3cea2426d3c4a0ed426dff3e170bb394 \
+			6.2.023 md5 6331bea240dec80c1ee7577812fde9cb \
+			6.2.024 md5 be794c1326628b5fd3a79840f1319b74 \
 			6.2.025 md5 5e75432f0cb97adba3405c5c3a86e7a8 \
 			6.2.026 md5 356b371dd265bbe672fc3928c432d67f \
 			6.2.027 md5 22965afbedd325d4d9d8694bbf973c63 \
@@ -26,14 +36,21 @@
 			6.2.030 md5 71013fca4dc5836b20bfd84fc00b7ff0 \
 			6.2.031 md5 f6bcf660cdd773708f1214460808dec9 \
 			6.2.032 md5 2630880791f4ff0f42ba13f5b28ea46c \
+			6.2.033 md5 e685c3e1bafa3f84d2983aab7d7860b1 \
 			6.2.034 md5 ba8803ff432e803b8d8b5a191943c035 \
 			6.2.035 md5 a7aa92d8af24dcc1c3ea0e438d31639d \
+			6.2.036 md5 491eb5460ea802833b2568e1859daaaa \
 			6.2.037 md5 415af2368f02311deb4fe2b039c45a11 \
+			6.2.038 md5 87a62da93312b450e439b429b015caa4 \
+			6.2.039 md5 9034b2f1ed3e6199a0d8b7f42e31a116 \
 			6.2.040 md5 4434f626a1633a404858060a9596c256 \
+			6.2.041 md5 c99fa521c5918f2c5d724c50f85d604d \
+			6.2.042 md5 e9beae2b0ec9316ecd50fd4beb285ccd \
 			6.2.043 md5 9a882b8346eb84c66f278d69919eb3a2 \
 			6.2.044 md5 1330021bd0c4580e31d6177a274e4b94 \
 			6.2.045 md5 14a5020f0d9f50717ad0fe96f1848d72 \
 			6.2.046 md5 ae65470d358441efaeed59869fab26a7 \
+			6.2.047 md5 326e8c2af8c98421c46c96f3a3871fde \
 			6.2.048 md5 16705bf1f0604c293cd8387015007187 \
 			6.2.049 md5 f09e652e0887d2da1f333871405876b2 \
 			6.2.050 md5 5f03daaf8eee1c1ace72b05d20613c9f \
@@ -42,7 +59,130 @@
 			6.2.053 md5 992be73d492153ea097ff42636f96493 \
 			6.2.054 md5 9f6be49078a96ccb5fd535d31c407702 \
 			6.2.055 md5 013ef3ae7d987b185c092f74fd8e48b2 \
+			6.2.056 md5 79c34dd39a3c6c5637a1ebd286470b4a \
+			6.2.057 md5 e56c2212ea2883f363f2c72f66840790 \
 			6.2.058 md5 71eb589f69538a991303154cddaa7cc9 \
 			6.2.059 md5 99a4ddd27e2fd95a2eea531317a39610 \
 			6.2.060 md5 603550db20af784a255f711aad13ab66 \
-			6.2.061 md5 e47e2b5673b19f28d73c339114e685fe
+			6.2.061 md5 e47e2b5673b19f28d73c339114e685fe \
+			6.2.062 md5 80e938742670fa139b1ae0b0e6c0d067 \
+			6.2.063 md5 5cd1abdd42417a475333e8551a2060d0 \
+			6.2.064 md5 76cd473cf53e22a4e21b7e06a035ee61 \
+			6.2.065 md5 ee2ecd97b170f5b08bcd0547076a2371 \
+			6.2.066 md5 bf6a44516e452b03c3f27d1ac7be6802 \
+			6.2.067 md5 a8fac41f9f55906441f8e759ebc9ca93 \
+			6.2.068 md5 98690c7c4acee6e569dcc2f661fddba0 \
+			6.2.069 md5 830ab502bc5ec656a5a0bd570d5dd5ee \
+			6.2.070 md5 1e438c36a963e2a00325807c61d77338 \
+			6.2.071 md5 7fedfa4b42fde3738bdddd5b63107eab \
+			6.2.072 md5 f076325656617c268beabee14b95e5bf \
+			6.2.073 md5 4c78d0d963d01bcd73673c6dbccfbd3b \
+			6.2.074 md5 eb8072d11d34678ff68882f227b8a09a \
+			6.2.075 md5 9422339e5faea84d76bed965b693f33c \
+			6.2.076 md5 0e8c4391aaf5eab76257f33f3823399a \
+			6.2.077 md5 9b0838e5987cdebb71f876269c975c6a \
+			6.2.078 md5 ea49f805f4f85295a15455bc8be8727f \
+			6.2.079 md5 9ef2027cc36989cb6959689e5ae86866 \
+			6.2.080 md5 40cab9544a82e7db9db2cafda029838e \
+			6.2.081 md5 5a6e9a9139616395c08e70c95bf91fd2 \
+			6.2.082 md5 0260d40bb931ea5200356848e012b6c4 \
+			6.2.083 md5 14ddbbf72f378dd62259cee3753a435b \
+			6.2.084 md5 a994b2209e24179c31f63ce56cd3ca6e \
+			6.2.085 md5 b77789e4feeae3fefb26b3191437d0b9 \
+			6.2.086 md5 5470ddc55f94f344605fd1a5fb94f82f \
+			6.2.087 md5 c932ca214a4b9a7d45bbe140fb5ccc10 \
+			6.2.088 md5 d01b90f0553ad707a43438ec389a84bb \
+			6.2.089 md5 3797203e60b1854a0934b3740a7c5f57 \
+			6.2.090 md5 f59eaf8a2e0b73bbff46d0af8e3ceada \
+			6.2.091 md5 327b4cea2097ceb21413276305bb96ba \
+			6.2.092 md5 d440de159859aed0313613dabf87b5dc \
+			6.2.093 md5 56663533ebdc821013001106412542d1 \
+			6.2.094 md5 d1066d845aa41ed12018bd19d6af9ab5 \
+			6.2.095 md5 759a6b50cc5a70218f3b0a50fa8f67d8 \
+			6.2.096 md5 aa8247cac8dac2f466c49cddac568aaa \
+			6.2.097 md5 f4ef2bcc307918e8e3e913f03be3d184 \
+			6.2.098 md5 242404050f82d91c432732f8cce83be1 \
+			6.2.099 md5 5b27267efe626be5a8a2971d57c0e8ca \
+			6.2.100 md5 ac42121f46700e9b93664e44e93a8afb \
+			6.2.101 md5 bff996fb4f6e590796325a697f7880dc \
+			6.2.102 md5 a220ecbb7d440f888d833853d3a1673f \
+			6.2.103 md5 2c4335aa2f2e5d77e24aa315a7ecf990 \
+			6.2.104 md5 952b50bb1ab0846c80327dbadd9d627e \
+			6.2.105 md5 0862253aa9971f14acc4da8ae88b9c9c \
+			6.2.106 md5 c51f5d29fb3c7161bea0be5de9118923 \
+			6.2.107 md5 36897d1524f856950a720077e888b19f \
+			6.2.108 md5 05ca8013e7e1961d78ea53e3c3f53c9e \
+			6.2.109 md5 ac4e6050d035db45b72f27edcb2e5686 \
+			6.2.110 md5 973d7f43652f2d04d9fa13f32e3361d3 \
+			6.2.111 md5 d39ada30faf8363441fbbd1573eaa1ff \
+			6.2.112 md5 143f46c080fad8733658138cb716189e \
+			6.2.113 md5 cd0f9f1b29c1ad692db2427fe2647aa5 \
+			6.2.114 md5 087c250d818146829d76822ba6ab0bb2 \
+			6.2.115 md5 ad6c9435ecec8b4050d30470847b7b8c \
+			6.2.116 md5 6ed4579fb0e5423aa389926f62a160b9 \
+			6.2.117 md5 bf2830c976d14eb1b0d0638a7e2c8e70 \
+			6.2.118 md5 d747b78045adc73f1eae83c35d0bc922 \
+			6.2.119 md5 17f18a4e6c15cb330a3da257e6230d7e \
+			6.2.120 md5 721eb53c0724cdbd435ebd626fed17a5 \
+			6.2.121 md5 85fe39809bcfc78339c30930f8e924f5 \
+			6.2.122 md5 23407062bf2db01d8af31e2459aaade3 \
+			6.2.123 md5 54fe5ce949d16ac5bc7b4bc0d37f46c4 \
+			6.2.124 md5 ec959ff62637617247ff344e6138a2f2 \
+			6.2.125 md5 3a57f1b236d60f41c353e4d31bbba4d5 \
+			6.2.126 md5 00eabb1ef218c095c6a0145d5b018756 \
+			6.2.127 md5 803b7efc8ae0d406a984c300ba148060 \
+			6.2.128 md5 0a7efa89cd34c5bb22c9b3aba96d6b83 \
+			6.2.129 md5 68fed2c3cfe87b63d898a96c9db8e290 \
+			6.2.130 md5 7f2ae41ec0217d8673c78751b3d278a1 \
+			6.2.131 md5 5469516dc2234dc3a318f159fa1344cb \
+			6.2.132 md5 81b5ca0c5256cc9731167af043a32955 \
+			6.2.133 md5 f7c41f69a718f0ea234fcbb18626d2b6 \
+			6.2.134 md5 fe8f64b05b4c4cbaccfb51b429ee03dd \
+			6.2.135 md5 ab02c2ab91f1fbee5c5a6263afd275b2 \
+			6.2.136 md5 3838a68c2ef68f492b34be6121097611 \
+			6.2.137 md5 3da3fd0a990718456f3b972acfcb78e4 \
+			6.2.138 md5 431721f615ab484d527ce305846b5c1e \
+			6.2.139 md5 4805299eb95883bf0d84e641f8c3543a \
+			6.2.140 md5 895001540c01d508ef9e06eaf10e62b1 \
+			6.2.141 md5 89b66a9e152719517a3f3ca63065ee6a \
+			6.2.142 md5 255857d0b72cfd4cb89a49e59a5d6216 \
+			6.2.143 md5 fcef583ad4596b9be5b0d0ca73a609bc \
+			6.2.144 md5 82da3bc2c9bb4246870299a3742a702e \
+			6.2.145 md5 d6f5e5e305bf627993fc6f32c366b13e \
+			6.2.146 md5 96ea39b5fa63b141371dd0393a4c8b1a \
+			6.2.147 md5 7fd17d661ae43c43171bb221479e02fd \
+			6.2.148 md5 22bbb1c772f409e7e036687f86eb883a \
+			6.2.149 md5 4670a26f554abf8ba6b9272db5015c4f \
+			6.2.150 md5 39d935357b6752f2d27cf4ea37d07109 \
+			6.2.151 md5 16e743f3ce9bb44027bbbcf064b3363b \
+			6.2.152 md5 63782508945cf7dc1bf604fdd38bd6d5 \
+			6.2.153 md5 e81f4c9ea3bc11a45296669e4dd3c718 \
+			6.2.154 md5 a28c0249db77875ace9e5e58a7c7f89b \
+			6.2.155 md5 27d365b18b54d7177a9902efd73d4d4c \
+			6.2.156 md5 44afcfdbbde59c492e32d43ee404892d \
+			6.2.157 md5 feef735a68590dafcd0e86cddbcdce84 \
+			6.2.158 md5 d804450e2329ef327ce3e9012081295c \
+			6.2.159 md5 40d50c762b7fc6995108754390ebe892 \
+			6.2.160 md5 c59efb3cee58acee8d580d72a6b58b7e \
+			6.2.161 md5 2c599cd2160af7a8434e2883c6717420 \
+			6.2.162 md5 60b1d7c4e775459f1b34c63b5bfe3946 \
+			6.2.163 md5 daec08b95f9b7b23a0bf2a9bd71b2095 \
+			6.2.164 md5 754a05df8db906812639753e6a687d8d \
+			6.2.165 md5 29b930209d43ff2edf8af5fa7669e98f \
+			6.2.166 md5 ca59ebbac19c5670f765b2dc2ffb5cea \
+			6.2.167 md5 0ea520f12b0dc53a882a9fe349f52146 \
+			6.2.168 md5 0cabe14e653f878ee98fd2af02d035b4 \
+			6.2.169 md5 127df017cd12b94a602799591a75c697 \
+			6.2.170 md5 dbe8d3d944b088dcd59eb740d723d828 \
+			6.2.171 md5 567bb5416ac2a8e456c9c0094ad4936d \
+			6.2.172 md5 1db8844008fe72db3d6296725173b799 \
+			6.2.173 md5 03bf372b1cf86cdef6b4b900221ae127 \
+			6.2.174 md5 cf3d885cf17754c5aaf19dc95c8f0218 \
+			6.2.175 md5 2dc6ce9f6ef6a9cfdd87a23327ecde67 \
+			6.2.176 md5 43c3b6d717da34979b2b33d3793bed08 \
+			6.2.177 md5 1fad63f81ae19b61f726a9809f6755ed \
+			6.2.178 md5 41d89a89a07d5fe7f00f11b47a785417 \
+			6.2.179 md5 940f838e713077d784c033f27e9e8591 \
+			6.2.180 md5 aa27519583d68b23cb43a77a6ac26a90 \
+			6.2.181 md5 f7f643d3391efb54d035e3655c0c274f
+