? mail/thunderbird
? net/axel
? net/gift
? net/gift-fasttrack
? net/gift-gnutella
? net/gift-openft
? www/firefox
Index: devel/glib2/Portfile
===================================================================
RCS file: /Volumes/src/cvs/od/proj/darwinports/dports/devel/glib2/Portfile,v
retrieving revision 1.31
diff -a -u -u -r1.31 Portfile
--- devel/glib2/Portfile	2 Jan 2005 06:03:10 -0000	1.31
+++ devel/glib2/Portfile	16 Jan 2005 15:30:08 -0000
@@ -1,8 +1,9 @@
-# $Id: Portfile,v 1.31 2005/01/02 06:03:10 mij Exp $
+# $Id: Portfile,v 1.30 2004/10/25 20:17:03 toby Exp $
 
 PortSystem 1.0
 name		glib2
-version		2.6.0
+version		2.6.1
+revision        1
 categories	devel
 maintainers	mij@opendarwin.org
 description	Library with data structure functions and other constructs
@@ -16,7 +17,7 @@
 master_sites	gnome:sources/glib/2.6
 
 distname	glib-${portversion}
-checksums	md5 649b89c8bfd152feea6db6f68b7cd54e
+checksums	md5 b7a07863d66f328bafadfe7747b85274
 
 use_bzip2	yes
 
@@ -33,14 +34,18 @@
 
 variant puredarwin { depends_run bin:perl:perl5.8 }
 
+post-patch	{ reinplace "s|data_dirs = \"/usr|data_dirs = \"${prefix}/share:/usr|g" ${worksrcpath}/glib/gutils.c
+                  reinplace "s|path = \"/bin|path = \"${prefix}/bin:/bin|g" ${worksrcpath}/glib/gutils.c ${worksrcpath}/glib/gspawn.c
+}
+
 post-destroot {
-		system "ln -fs libglib-2.0.0.600.0.dylib \
+		system "ln -fs libglib-2.0.0.400.7.dylib \
 		    ${destroot}${prefix}/lib/libglib.2.dylib"
-		system "ln -fs libgmodule-2.0.0.600.0.dylib \
+		system "ln -fs libgmodule-2.0.0.400.7.dylib \
 		    ${destroot}${prefix}/lib/libgmodule.2.dylib"
-		system "ln -fs libgobject-2.0.0.600.0.dylib \
+		system "ln -fs libgobject-2.0.0.400.7.dylib \
 		    ${destroot}${prefix}/lib/libgobject.2.dylib"
-		system "ln -fs libgthread-2.0.0.600.0.dylib \
+		system "ln -fs libgthread-2.0.0.400.7.dylib \
 		    ${destroot}${prefix}/lib/libgthread.2.dylib"
 		file delete ${destroot}${prefix}/lib/charset.alias
 }
Index: gnome/control-center/Portfile
===================================================================
RCS file: /Volumes/src/cvs/od/proj/darwinports/dports/gnome/control-center/Portfile,v
retrieving revision 1.9
diff -a -u -u -r1.9 Portfile
--- gnome/control-center/Portfile	19 Sep 2004 18:38:45 -0000	1.9
+++ gnome/control-center/Portfile	16 Jan 2005 15:30:08 -0000
@@ -1,7 +1,7 @@
 # $Id: Portfile,v 1.9 2004/09/19 18:38:45 olegb Exp $
 PortSystem 1.0
 name		control-center
-version		2.8.0
+version		2.8.1
 description	Control center for GNOME 2.0 project.
 long_description        ${description}
 maintainers	gnome-darwinports@opendarwin.org
@@ -9,12 +9,24 @@
 platforms	darwin 
 homepage	http://www.gnome.org/
 master_sites    gnome:sources/control-center/2.8/
-checksums	md5 300fb361af4645dd9b0154ecd18b2256
+checksums	md5 7bd9c12b9abb05b6fcf7b4906b6918ea
 depends_lib	lib:nautilus:nautilus
 use_bzip2 	yes
 configure.args  --mandir=${prefix}/share/man
 configure.env   CPPFLAGS="-L${prefix}/lib -I${prefix}/include"  \
                 CFLAGS="-no-cpp-precomp -flat_namespace -undefined suppress" 
+
+post-patch {
+    reinplace \
+	"s|g_strdup (\"/usr|g_strdup (\"${prefix}/share:/usr|g" \
+	${worksrcpath}/capplets/background/gnome-wp-xml.c
+    reinplace \
+	"s|/usr/share|${prefix}/share|g" \
+	${worksrcpath}/capplets/common/gnome-theme-info.c \
+	${worksrcpath}/libwindow-settings/metacity-window-manager.c
+    
+}
+
 post-install 	{ 
 		system " \
 		export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`&&\
Index: gnome/gnome-desktop/Portfile
===================================================================
RCS file: /Volumes/src/cvs/od/proj/darwinports/dports/gnome/gnome-desktop/Portfile,v
retrieving revision 1.14
diff -a -u -u -r1.14 Portfile
--- gnome/gnome-desktop/Portfile	9 Jan 2005 08:08:13 -0000	1.14
+++ gnome/gnome-desktop/Portfile	16 Jan 2005 15:30:08 -0000
@@ -1,7 +1,7 @@
 # $Id: Portfile,v 1.14 2005/01/09 08:08:13 jkh Exp $
 PortSystem 1.0
 name		gnome-desktop
-version		2.8.0
+version		2.8.1
 description	Additional UI API for GNOME 2
 long_description        This is a collection of APIs not included in \
 			libgnomeui as they have not undergone sufficient \
@@ -11,11 +11,13 @@
 platforms	darwin 
 homepage	http://www.gnome.org/
 master_sites    gnome:sources/gnome-desktop/2.8/
-checksums	md5 303b5a7db31e72fb74fcc9b6dcd860dc
+checksums	md5 47f9b9508c4a0349d66fa1138b521794
 patchfiles	patch_gnome-desktop-item.c
 depends_lib	lib:gnome-themes:gnome-themes lib:libiconv.2:libiconv
 depends_build	bin:scrollkeeper-extract:scrollkeeper
 use_bzip2 	yes
-configure.args  --mandir=${prefix}/share/man
+configure.args  --mandir=${prefix}/share/man \
+		--with-gnome-distributor=DarwinPorts \
+		--with-kde-datadir=${prefix}/share
 configure.env   CPPFLAGS="-L${prefix}/lib -I${prefix}/include" \
                 CFLAGS="-no-cpp-precomp -flat_namespace -undefined suppress"
Index: gnome/gnome-vfs/Portfile
===================================================================
RCS file: /Volumes/src/cvs/od/proj/darwinports/dports/gnome/gnome-vfs/Portfile,v
retrieving revision 1.21
diff -a -u -u -r1.21 Portfile
--- gnome/gnome-vfs/Portfile	9 Jan 2005 08:08:14 -0000	1.21
+++ gnome/gnome-vfs/Portfile	16 Jan 2005 15:30:08 -0000
@@ -2,6 +2,7 @@
 PortSystem 1.0
 name		gnome-vfs
 version		2.8.2
+revision	1
 description	This is the GNOME Virtual File System.
 long_description        This is the GNOME Virtual File System. \
 			GNOME VFS is currently used as one of the \
@@ -16,8 +17,16 @@
 patchfiles	patch_gnome-vfs-cdrom.c patch_gnome-vfs-utils.c \
 		patch_file-metod.c patch_bzip2-method.c patch_pty-open.c
 use_bzip2 	yes
-configure.args  --mandir=${prefix}/share/man --enable-ipv6
+configure.args  --mandir=${prefix}/share/man --enable-ipv6 --disable-static
 configure.env   CPPFLAGS="-L${prefix}/lib -I${prefix}/include"
+
+post-patch {
+    reinplace \
+	"s|data_dirs = \"/usr|data_dirs = \"${prefix}/share:/usr|g" \
+	${worksrcpath}/libgnomevfs/xdgmime.c \
+	${worksrcpath}/libgnomevfs/gnome-vfs-mime-info.c \
+	${worksrcpath}/libgnomevfs/eggdirfuncs.c
+}
 
 platform darwin 7 {
                 configure.env-append LDFLAGS="-lresolv" 
Index: x11/gtk2/Portfile
===================================================================
RCS file: /Volumes/src/cvs/od/proj/darwinports/dports/x11/gtk2/Portfile,v
retrieving revision 1.29
diff -a -u -u -r1.29 Portfile
--- x11/gtk2/Portfile	9 Jan 2005 19:18:04 -0000	1.29
+++ x11/gtk2/Portfile	16 Jan 2005 15:30:08 -0000
@@ -2,8 +2,8 @@
 
 PortSystem 1.0
 name		gtk2
-version		2.6.0
-revision	2
+version		2.6.1
+revision	0
 categories	x11
 maintainers	mij@opendarwin.org
 description	Gimp ToolKit version 2
@@ -17,7 +17,7 @@
 master_sites	gnome:sources/gtk+/2.6
 
 distname	gtk+-${portversion}
-checksums	md5 ca717c728264fa0b3302ca00da2bcfe4
+checksums	md5 146ed9d12c9506fcf8745ddb2c22530a
 
 use_bzip2	yes
 
@@ -34,12 +34,14 @@
 
 build.args	CFLAGS+="-I${x11prefix}/include"
 
-post-configure	{ reinplace "s|__PREFIX__|${prefix}|g" ${filespath}/gdk-pixbuf.loaders }
+post-patch	{ reinplace "s|xdg_data_dirs = \"/usr|xdg_data_dirs = \"${prefix}/share:/usr|g" ${worksrcpath}/gtk/xdgmime/xdgmime.c
+		  reinplace "s|g_strdup (\"/usr|g_strdup (\"${prefix}|g" ${worksrcpath}/gtk/gtkicontheme.c }
 
 platform darwin 6 { patchfiles-append patch-gtk-xdgmime-xdgmimemagic.c }
 
 post-destroot	{ system "ln -fs libgtk-x11-2.0.0.600.0.dylib ${destroot}${prefix}/lib/libgtk.2.dylib"
 		  system "ln -fs libgdk-x11-2.0.0.600.0.dylib ${destroot}${prefix}/lib/libgdk.2.dylib"
 		  system "install -d -m 755 ${destroot}${prefix}/etc/gtk-2.0"
-		  system "cp ${filespath}/gdk-pixbuf.loaders ${destroot}${prefix}/etc/gtk-2.0/gdk-pixbuf.loaders"
+		  file copy ${filespath}/gdk-pixbuf.loaders ${destroot}${prefix}/etc/gtk-2.0/gdk-pixbuf.loaders
+		  reinplace "s|__PREFIX__|${prefix}|g" ${destroot}${prefix}/etc/gtk-2.0/gdk-pixbuf.loaders
 		  system "env LANG=C DYLD_LIBRARY_PATH=${destroot}${prefix}/lib ${destroot}${prefix}/bin/gtk-query-immodules-2.0 > ${destroot}${prefix}/etc/gtk-2.0/gtk.immodules" }